/* Miscelancelous utility functions

   Copyright 2000 Hans de Goede
   
   This file and the acompanying files in this directory are free software;
   you can redistribute them and/or modify them under the terms of the GNU
   Library General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.

   These files are distributed in the hope that they will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with these files; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
#ifndef __MISC_H
#define __MISC_H
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include "begin_code.h"

/* clock stuff */
/* some platforms don't define CLOCKS_PER_SEC, according to posix it should
   always be 1000000, so asume that's the case if it is not defined */
#ifndef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC 1000000
#endif

#ifdef HAVE_GETTIMEOFDAY

typedef long uclock_t;
uclock_t uclock(void);
#define UCLOCKS_PER_SEC 1000000

#else

typedef clock_t uclock_t;
#if (CLOCKS_PER_SEC < 1000)
/* the resolution of the normal clock() call isn't good enough, so we fake a
   higher resolution */
#define uclock() (clock() << 5)
#define UCLOCKS_PER_SEC (CLOCKS_PER_SEC << 5)
#else
#define UCLOCKS_PER_SEC CLOCKS_PER_SEC
#define uclock() clock()
#endif

#endif

void print_colums(const char *text1, const char *text2);
void fprint_colums(FILE *f, const char *text1, const char *text2);

#include "end_code.h"
#endif /* ifndef __MISC_H */
